<template>
  <div class="Detail">
    <u-navbar title="Copilot小助理" title-color="#000" title-width="300" title-size="32" :title-bold="true" :background="backgroundNavbar" :height="44"></u-navbar>
    <div class="list-bg">
      <div class="search-content">
        <u-search v-model="searchVal" :clearabled="true" placeholder="请输入搜索关键词…" :show-action="false"
          bg-color="#fff" search-icon-color="#E2E8F1" color="#666" height="72" @search="getSearchList" @clear="handerClear">
        </u-search>
      </div>
    </div>
    <div class="list-content">
      <div v-for="(item, index) in messageList" :key="index">
        <div class="send-time">{{item.createTime.substring(5, 16)}}</div>
        <div :class="item.userType == 1 ? 'item-left' : 'item-right'">
          <img src="https://cdn.cunwuyun.cn/wechat/baiduAI/user-img.png" alt="" class="user-img" v-if="item.userType == 1">
          <div class="item" :class="'item'+index">
            <u-icon name="play-right-fill" color="#CCE2FF" size="20" v-if="item.userType != 1" class="u-icon-right"></u-icon>
            <u-icon name="play-left-fill" color="#F3F5F7" size="20" v-if="item.userType == 1" class="u-icon-left"></u-icon>
            <div class="voice-div" v-if="item.sdkFileUrl" @click="play(item.sdkFileUrl, index)">
              <span>8”</span>
              <img src="https://cdn.cunwuyun.cn/wechat/baiduAI/play-d.gif" alt="" v-if="item.isPlay">
              <img src="https://cdn.cunwuyun.cn/wechat/baiduAI/play-j.png" alt="" v-else>
            </div>
            <p v-if="!item.sdkFileUrl">{{item.content || ''}}</p>
          </div>
          <img src="https://cdn.cunwuyun.cn/wechat/baiduAI/user-img.png" alt="" class="user-img" v-if="item.userType != 1">
        </div>
      </div>
      <AiEmpty v-if="!messageList.length"/>
    </div>
  </div>
</template>

<script>

import {mapActions, mapState} from "vuex";
export default {
  customNavigation: true,
  enablePullDownRefresh: true,
  name: 'Detail',
  data() {
    return {
      backgroundNavbar: {
        background: 'url(https://cdn.cunwuyun.cn/wechat/biaopin/residentAssistant/header-bg.jpeg) no-repeat',
        backgroundSize: 'cover',
      },
      searchVal: '',
      messageList: [
        // {
        //   userType: 0,
        //   sdkFileUrl: 'http://test87ftp.cunwuyun.cn/20240104/output.mp3',
        //   isPlay: false
        // }
      ],
      current: 1,
      pages: 2,
      aiConfigId: '',
      conversationId: '',
      isFirst: true
    }
  },
  computed: {
    ...mapState(['user', 'token']),
  },
  onLoad(e) {
    this.aiConfigId = e.aiConfigId
    this.conversationId = e.conversationId
    this.getHistoryList()
  },
  onPullDownRefresh() {
    if(this.current > this.pages) {
      return this.$u.toast('没有更多记录')
    }
    this.current = this.current + 1
    this.getHistoryList()
  },
  methods: {
    ...mapActions(['autoLogin']),
    getHistoryList() {
      if(!this.token) {
        return this.$u.toast("请先进行登录")
      }
      this.$loading()
      this.$instance.post(`/app/appaicopilotinfo/list?current=${this.current}&size=10&content=${this.searchVal}&aiConfigId=${this.aiConfigId}&conversationId=${this.conversationId}`).then(res => {
        if(res.code == 0 && res.data.records.length) {
          res.data.records.map((item) => {
            if(item.sdkFileUrl) {
              item.isPlay = false
            }
          })
          this.messageList = this.current == 1 ? res.data.records : [...res.data.records, ...this.messageList]
          var idPage = res.data.records.length-1
          if(this.isFirst) { //初始化不下滑到最新页
            this.isFirst = false
          }else {
            this.$nextTick(() => {  
              uni.pageScrollTo({
                duration: 300,
                selector: this.current == 1 ? `.item${this.messageList.length-1}` :  `.item${idPage}`
              });
            })
          }
          this.pages = res.data.pages
          this.$hideLoading()
        }else {
          if(this.current == 1) {
            this.messageList = []
          }
          
        }
      })
    },
    getSearchList() {
      this.current = 1
      this.getHistoryList()
    },
    handerClear() {
      this.searchVal = ''
      this.getSearchList()
    },
    play(src, index) {
      innerAudioContext.stop();
      if(this.messageList[index].isPlay) {
        innerAudioContext.onStop(() => {
          this.messageList[index].isPlay = false
        })
        return
      }
      
      this.messageList.map((item) => {
        if(item.sdkFileUrl) {
          item.isPlay = false
        }
      })
      this.messageList[index].isPlay = true
      innerAudioContext.src = src;

      this.$nextTick(() => {
        innerAudioContext.play();
      })
      innerAudioContext.onEnded(() => {
        this.messageList[index].isPlay = false
      })
    },
    playStop(index) {
      innerAudioContext.stop();
      innerAudioContext.onStop(() => {
        this.messageList[index].isPlay = false
      })
    },
  },
}
</script>

<style lang="scss" scoped>
@import "~dvcp-wui/common";
page {
  height: 100%;
}
.Detail {
  height: 100vh;
  background-color: #fff;
  position: relative;
  .list-bg {
    width: 100%;
    height: 420px;
    background-image: url("https://cdn.cunwuyun.cn/wechat/biaopin/residentAssistant/content-top-bg.png");
    position: fixed;
    left: 0;
    z-index: 1;
    background-size: 100vw;
    background-repeat: no-repeat;
    .search-content {
      padding: 32px;
      width: 100%;
      box-sizing: border-box;
      position: fixed;
      left: 0;
      z-index: 99;
      background: linear-gradient(to bottom, #D7EDFE, #EAF5FE);
    }
  }
  .list-content {
    width: 100%;
    box-sizing: border-box;
    background-color: #fff;
    padding: 144px 32px 364px;
    .send-time {
      display: block;
      width: 100%;
      line-height: 28px;
      font-family: PingFangSC-Regular;
      font-weight: 400;
      font-size: 20px;
      color: #999;
      text-align: center;
      margin-bottom: 28px;
    }
    .user-img {
      display: inline-block;
      width: 72px;
      height: 72px;
      vertical-align: top;
    }
    .item {
      display: inline-block;
      max-width: 440px;
      border-radius: 8px;
      padding: 18px;
      box-sizing: border-box;
      margin-bottom: 28px;
      position: relative;
      .voice-div {
        img {
          width: 26px;
          height: 28px;
        }
        span {
          display: inline-block;
          color: #333;
          font-size: 28px;
          font-family: PingFangSC;
          line-height: 28px;
          margin-right: 68px;
        }
      }
      p {
        word-break: break-all;
        line-height: 40px;
        font-family: SourceHanSansCN-Regular;
        font-size: 32px;
        color: #333;
      }
    }
    .item-right {
      display: flex;
      justify-content: flex-end;
      .item {
        background-color: #CCE2FF;
      }
      .user-img {
        margin-left: 24px;
      }
      .u-icon-right {
        position: absolute;
        top: 12px;
        right: -12px;
      }
    }
    .item-left {
      .item {
        background-color: #F3F5F7;
      }
      .user-img {
        margin-right: 24px;
      }
      .u-icon-left {
        position: absolute;
        top: 12px;
        left: -12px;
      }
    }
  }
}
</style>
